#ifdef HAVE_CONFIG_H
#  include <config.h>
#endif

#include <pwd.h>
#include <gnome.h>

#include "callbacks.h"
#include "interface.h"
#include "support.h"

#include "var.h"
#include "gtudb.h"
#include "mw.h"
#include "pw.h"
#include "dw.h"
#include "bw.h"
#include "sw.h"
#include "sw.h"
#include "fdw.h"
#include "idbw.h"


void on_mw_menu_zakoncz1_activate (GtkMenuItem* menuitem, gpointer user_data)
{
	on_main_window_delete_event (NULL, NULL, NULL);
    gtk_main_quit();
}


void on_main_window_destroy (GtkObject*object, gpointer user_data)
{
    gtk_main_quit();
}


void on_main_window_show (GtkWidget *widget, gpointer user_data)
{
	mw_show (widget);
}


void on_mw_calendar_day_selected (GtkCalendar *calendar, gpointer user_data)
{
	// Pobieramy date z kalendarza
	type_date tmp;
	gtk_calendar_get_date (calendar, &tmp.year, &tmp.month, &tmp.day);
	tmp.month++;
	
	// Jesli data jest poprawna to wczytujemy wpis
	mw_edit_entry (tmp, TRUE);
}


void on_mw_marks_clist_select_row (GtkCList *clist, gint row, gint column, GdkEvent *event, gpointer user_data)
{
	mw_marks_clist_rowselected = row;
	
	GtkWidget *mw_marks_delete_btn = (gpointer) lookup_widget (GTK_WIDGET (mw_widget), "mw_marks_delete_btn");
	gtk_widget_set_sensitive (GTK_WIDGET (mw_marks_delete_btn), TRUE);
	
	GtkWidget *mw_marks_save_btn = (gpointer) lookup_widget (GTK_WIDGET (mw_widget), "mw_marks_save_btn");
	gtk_widget_set_sensitive (GTK_WIDGET (mw_marks_save_btn), TRUE);
}


void on_mw_marks_clist_unselect_row (GtkCList *clist, gint row, gint column, GdkEvent *event, gpointer user_data)
{
	mw_marks_clist_rowselected = -1;
	
	GtkWidget *mw_marks_delete_btn = (gpointer) lookup_widget (GTK_WIDGET (mw_widget), "mw_marks_delete_btn");
	gtk_widget_set_sensitive (GTK_WIDGET (mw_marks_delete_btn), FALSE);
	
	GtkWidget *mw_marks_save_btn = (gpointer) lookup_widget (GTK_WIDGET (mw_widget), "mw_marks_save_btn");
	gtk_widget_set_sensitive (GTK_WIDGET (mw_marks_save_btn), FALSE);
}


void on_mw_marks_add_btn_clicked(GtkButton * button, gpointer user_data)
{
	mw_marks_clist_rowselected = -1;
	
	mwes_widget = create_main_window_edit_subject ();
	gtk_widget_show (GTK_WIDGET (mwes_widget));
}


void on_mw_marks_delete_btn_clicked(GtkButton * button, gpointer user_data)
{
	if (mw_marks_clist_rowselected >= 0)
		mw_marks_clist_remove (mw_marks_clist_rowselected);
}


void on_mw_marks_save_btn_clicked (GtkButton *button, gpointer user_data)
{
	if (mw_marks_clist_rowselected >= 0) {
		mwes_widget = create_main_window_edit_subject ();
		mwes_marks_edit (mw_marks_clist_rowselected);
		gtk_widget_show (GTK_WIDGET (mwes_widget));
	}
}


void on_about_activate (GtkMenuItem *menuitem, gpointer user_data)
{
	GtkWidget *about_window = create_about_window ();
	gtk_widget_show (GTK_WIDGET (about_window));
}


void on_idbw_btn_cancel_clicked (GtkButton *button, gpointer user_data)
{
	gtk_widget_hide (GTK_WIDGET (idbw_widget));
	gnome_app_message (GNOME_APP (mw_widget), _("The data from older version of the program has been imported. \n\nWe recommend you to write hours in lesson-schedule.\nSelect lessons-schedule option from settings menu."));
}


gboolean on_main_window_delete_event (GtkWidget *widget, GdkEvent *event, gpointer user_data)
{
	mw_edit_entry (entry_date, TRUE);
	gtudb_write ();
	gtudb_settings_write ();
	
	return FALSE;
}


void on_pw_cancel_btn_clicked (GtkButton *button, gpointer user_data)
{
	gtudb_plan_read ();
	gtk_widget_hide (pw_widget);
}


void on_pw_ok_btn_clicked (GtkButton *button, gpointer user_data)
{
	gtudb_plan_write (); // zapisujemy plan lekcji
	gtudb_plan_read ();  // ponownie wczytujemy plan lekcji
	
	gtk_widget_hide (pw_widget); // ...i zamykamy okno
}



void on_epw_cancel_btn_clicked (GtkButton *button, gpointer user_data)
{
	gtk_widget_hide (epw_widget);
}


void on_epw_ok_btn_clicked (GtkButton *button, gpointer user_data)
{
	// zapisujemy dane
	pw_epw_get_subjects ();
	
	// odswiezamy plan lekcji !
	pw_load_subjects ();
	
	// ukrywamy okno
	gtk_widget_hide (epw_widget);
}


void on_pw_edit_d0_btn_clicked (GtkButton *button, gpointer user_data)
{
	ephw_widget = create_edit_plan_hours_window ();
	
	pw_ephw_load_hours ();
	gtk_widget_show    (GTK_WIDGET (ephw_widget));
}


void on_pw_edit_d1_btn_clicked (GtkButton *button, gpointer user_data)
{
	epw_widget  = create_edit_plan_window ();
	
	pw_epw_edit_day = 1;
	pw_epw_load_subjects (1);
	gtk_widget_show (GTK_WIDGET (epw_widget));
}


void on_pw_edit_d2_btn_clicked (GtkButton *button, gpointer user_data)
{
	epw_widget  = create_edit_plan_window ();
	
	pw_epw_edit_day = 2;
	pw_epw_load_subjects (2);
	gtk_widget_show (GTK_WIDGET (epw_widget));
}


void on_pw_edit_d3_btn_clicked (GtkButton *button, gpointer user_data)
{
	epw_widget  = create_edit_plan_window ();
	
	pw_epw_edit_day = 3;
	pw_epw_load_subjects (3);
	gtk_widget_show (GTK_WIDGET (epw_widget));
}


void on_pw_edit_d4_btn_clicked (GtkButton *button, gpointer user_data)
{
	epw_widget  = create_edit_plan_window ();
	
	pw_epw_edit_day = 4;
	pw_epw_load_subjects (4);
	gtk_widget_show (GTK_WIDGET (epw_widget));
}


void on_pw_edit_d5_btn_clicked (GtkButton *button, gpointer user_data)
{
	epw_widget  = create_edit_plan_window ();
	
	pw_epw_edit_day = 5;
	pw_epw_load_subjects (5);
	gtk_widget_show (GTK_WIDGET (epw_widget));
}


void on_pw_edit_d6_btn_clicked (GtkButton *button, gpointer user_data)
{
	epw_widget  = create_edit_plan_window ();
	
	pw_epw_edit_day = 6;
	pw_epw_load_subjects (6);
	gtk_widget_show (GTK_WIDGET (epw_widget));
}


void on_epw_add_btn_clicked (GtkButton *button, gpointer user_data)
{
	if (pw_epw_select_hour >= 0) {
		GtkWidget *epw_subject_entry = (gpointer) lookup_widget (GTK_WIDGET (epw_widget), "epw_subject_entry");
		GtkWidget *epw_time_clist    = (gpointer) lookup_widget (GTK_WIDGET (epw_widget), "epw_time_clist");
		gchar     *tmp;
		
		gtk_clist_get_text (GTK_CLIST (epw_time_clist), pw_epw_select_hour, 0, &tmp);
		pw_epw_add_subject ((gchar *) gtk_entry_get_text (GTK_ENTRY (epw_subject_entry)), g_strdup (tmp));
		pw_epw_time_clist_remove (pw_epw_select_hour);
		
		gtk_entry_set_text (GTK_ENTRY (epw_subject_entry), "");
	}
}


void on_plan_activate (GtkMenuItem *menuitem, gpointer user_data)
{
	pw_show ();
}


void on_epw_subjects_clist_select_row (GtkCList *clist, gint row, gint column, GdkEvent *event, gpointer user_data)
{
	GtkWidget *epw_remove_btn = (gpointer) lookup_widget (GTK_WIDGET (epw_widget), "epw_remove_btn");
	gtk_widget_set_sensitive (GTK_WIDGET (epw_remove_btn), TRUE);
	
	pw_epw_select_subject = row;
}


void on_epw_subjects_clist_unselect_row (GtkCList *clist, gint row, gint column, GdkEvent *event, gpointer user_data)
{
	GtkWidget *epw_remove_btn = (gpointer) lookup_widget (GTK_WIDGET (epw_widget), "epw_remove_btn");
	gtk_widget_set_sensitive (GTK_WIDGET (epw_remove_btn), FALSE);
	
	pw_ephw_select_hour = -1;
}


void on_ephw_add_hour_btn_clicked (GtkButton *button, gpointer user_data)
{
	GtkWidget *ephw_hour_entry = (gpointer) lookup_widget (GTK_WIDGET (ephw_widget), "ephw_hour_entry");
	
	pw_ephw_add_hour ((gchar *) gtk_entry_get_text (GTK_ENTRY (ephw_hour_entry)));
	gtk_entry_set_text (GTK_ENTRY (ephw_hour_entry), "");
}


void on_ephw_remove_hour_btn_clicked (GtkButton *button, gpointer user_data)
{
	pw_ephw_remove_hour (pw_ephw_select_hour);
}


void on_ephw_hours_clist_select_row (GtkCList *clist, gint row, gint column, GdkEvent *event, gpointer user_data)
{
	GtkWidget *ephw_remove_hour_btn = (gpointer) lookup_widget (GTK_WIDGET (ephw_widget), "ephw_remove_hour_btn");
	gtk_widget_set_sensitive (GTK_WIDGET (ephw_remove_hour_btn), TRUE);
	
	pw_ephw_select_hour = row;
}


void on_ephw_hours_clist_unselect_row (GtkCList *clist, gint row, gint column, GdkEvent *event, gpointer user_data)
{
	GtkWidget *ephw_remove_hour_btn = (gpointer) lookup_widget (GTK_WIDGET (ephw_widget), "ephw_remove_hour_btn");
	gtk_widget_set_sensitive (GTK_WIDGET (ephw_remove_hour_btn), FALSE);
	
	pw_ephw_select_hour = -1;
}


void on_ephw_cancel_btn_clicked (GtkButton *button, gpointer user_data)
{
	if (g_slist_length (gtudb_plan_list [0]) == 0)
		pw_disable_buttons ();
	else
		pw_enable_buttons ();
	
	gtk_widget_hide (GTK_WIDGET (ephw_widget));
}


void on_ephw_ok_btn_clicked (GtkButton *button, gpointer user_data)
{
	// zapisujemy godziny
	pw_ephw_get_hours ();
	
	// odswiezamy plan lekcji !
	pw_load_subjects ();
	
	// przyciski w oknie planu lekcji
	if (g_slist_length (gtudb_plan_list [0]) == 0)
		pw_disable_buttons ();
	else
		pw_enable_buttons ();
	
	// ukrywamy okno
	gtk_widget_hide (GTK_WIDGET (ephw_widget));
}


void on_epw_remove_btn_clicked (GtkButton *button, gpointer user_data)
{
	pw_epw_remove_subject (pw_epw_select_subject);
}


void on_epw_time_clist_select_row (GtkCList *clist, gint row, gint column, GdkEvent *event, gpointer user_data)
{
	GtkWidget *epw_add_btn       = (gpointer) lookup_widget (GTK_WIDGET (epw_widget), "epw_add_btn");
	GtkWidget *epw_subject_entry = (gpointer) lookup_widget (GTK_WIDGET (epw_widget), "epw_subject_entry");
	
	pw_epw_select_hour = row;
	
	if ((pw_epw_select_hour >= 0) && (strlen (gtk_entry_get_text (GTK_ENTRY (epw_subject_entry))) > 0))
		gtk_widget_set_sensitive (GTK_WIDGET (epw_add_btn), TRUE);
	else
		gtk_widget_set_sensitive (GTK_WIDGET (epw_add_btn), FALSE);
}


void on_epw_time_clist_unselect_row (GtkCList *clist, gint row, gint column, GdkEvent *event, gpointer user_data)
{
	GtkWidget *epw_add_btn       = (gpointer) lookup_widget (GTK_WIDGET (epw_widget), "epw_add_btn");
	
	pw_epw_select_hour = -1;
	
	gtk_widget_set_sensitive (GTK_WIDGET (epw_add_btn), FALSE);
}


void on_epw_subject_entry_changed (GtkEditable *editable, gpointer user_data)
{
	GtkWidget *epw_add_btn = (gpointer) lookup_widget (GTK_WIDGET (epw_widget), "epw_add_btn");
	
	if ((pw_epw_select_hour >= 0) && (strlen (gtk_entry_get_text (GTK_ENTRY (editable))) > 0))
		gtk_widget_set_sensitive (GTK_WIDGET (epw_add_btn), TRUE);
	else
		gtk_widget_set_sensitive (GTK_WIDGET (epw_add_btn), FALSE);
}


void on_ephw_hour_entry_changed (GtkEditable *editable, gpointer user_data)
{
	GtkWidget *ephw_add_hour_btn = (gpointer) lookup_widget (GTK_WIDGET (ephw_widget), "ephw_add_hour_btn");
	
	if (strlen (gtk_entry_get_text (GTK_ENTRY (editable))) > 0)
		gtk_widget_set_sensitive (GTK_WIDGET (ephw_add_hour_btn), TRUE);
	else
		gtk_widget_set_sensitive (GTK_WIDGET (ephw_add_hour_btn), FALSE);
}


void on_mw_tb_add_btn_clicked (GtkToolButton *toolbutton, gpointer user_data)
{
	mw_marks_clist_load_subjects (date_get_weekday (entry_date));
}


void on_mw_tb_search_btn_clicked (GtkToolButton *toolbutton, gpointer user_data)
{
	on_search_tests_activate (NULL, NULL);
}


void on_mw_tb_exit_btn_clicked (GtkToolButton *toolbutton, gpointer user_data)
{
	on_main_window_delete_event (NULL, NULL, NULL);
	gtk_main_quit();
}


void on_pwmh_ok_btn_clicked (GtkButton *button, gpointer user_data)
{
	gtk_widget_hide (GTK_WIDGET (pwmh_widget));
	
	pw_widget = create_plan_window ();
	gtk_widget_show (GTK_WIDGET (pw_widget));
	
	ephw_widget = create_edit_plan_hours_window ();
	gtk_widget_show (GTK_WIDGET (ephw_widget));
}


void on_mwes_cancel_btn_clicked (GtkButton *button, gpointer user_data)
{
	GtkWidget *mw_marks_clist = (gpointer) lookup_widget (GTK_WIDGET (mw_widget), "mw_marks_clist");
	gtk_clist_unselect_all (GTK_CLIST (mw_marks_clist));
	
	gtk_widget_hide (GTK_WIDGET (mwes_widget));
}


void on_mwes_ok_btn_clicked (GtkButton *button, gpointer user_data)
{
	if (mw_marks_clist_rowselected > -1)
		mw_marks_clist_remove (mw_marks_clist_rowselected);
	
	mwes_marks_add ();
	gtk_widget_hide (GTK_WIDGET (mwes_widget));
}


void on_pwmh_cancel_btn_clicked (GtkButton *button, gpointer user_data)
{
	gtk_widget_hide (GTK_WIDGET (pwmh_widget));
	
	pw_widget = create_plan_window ();
	gtudb_plan_num_hours (TRUE);
	pw_load_subjects ();
	pw_enable_buttons ();
	gtk_widget_show (GTK_WIDGET (pw_widget));
}


void on_insert_subjects_activate (GtkMenuItem *menuitem, gpointer user_data)
{
	on_mw_tb_add_btn_clicked (NULL, NULL);
}


void on_search_tests_activate (GtkMenuItem *menuitem, gpointer user_data)
{
	mwt_widget = create_main_window_tests ();
	mwt_show ();
}


void on_clear_subjects_activate (GtkMenuItem *menuitem, gpointer user_data)
{
	mw_marks_clist_clear  ();
	mw_tests_clist_clear  ();
	mw_quizes_clist_clear ();
}


void on_clear_notes_activate (GtkMenuItem *menuitem, gpointer user_data)
{
	mw_notes_textview_set_text ("");
}


void on_today_activate (GtkMenuItem *menuitem, gpointer user_data)
{
	GtkWidget *mw_calendar = (gpointer) lookup_widget (GTK_WIDGET (mw_widget), "mw_calendar");
	
	if (gtk_calendar_select_month (GTK_CALENDAR (mw_calendar), (date_today ().month - 1), date_today ().year))
		gtk_calendar_select_day (GTK_CALENDAR (mw_calendar), date_today ().day);
}


void on_gnutu_www_activate (GtkMenuItem *menuitem, gpointer user_data)
{
	gnome_url_show ("http://www.gnutu.org/", NULL);
}


void on_email_activate (GtkMenuItem *menuitem, gpointer user_data)
{
	gnome_url_show ("mailto: mkk@gnutu.org", NULL);
}


void on_forum_activate (GtkMenuItem *menuitem, gpointer user_data)
{
	gnome_url_show ("http://www.gnutu.org/?modul=forum", NULL);
}


void on_donate_activate (GtkMenuItem *menuitem, gpointer user_data)
{
	gnome_url_show ("http://www.gnutu.org/?modul=teksty&id_txt=wesprzyj_projekt", NULL);
}


void on_dw_cancel_btn_clicked (GtkButton *button, gpointer user_data)
{
	gtk_widget_hide (GTK_WIDGET (dw_widget));
}


void on_dw_ok_btn_clicked (GtkButton *button, gpointer user_data)
{
	dw_save_entry (dw_entry_date);
	gtk_widget_hide (GTK_WIDGET (dw_widget));
}


void on_diary_activate (GtkMenuItem *menuitem, gpointer user_data)
{
	dw_widget = create_diary_window ();
	
	dw_load_entry (entry_date);
	gtk_widget_show (GTK_WIDGET (dw_widget));
}


void on_dw_date_date_edit_date_changed (GnomeDateEdit *gnomedateedit, gpointer user_data)
{
	dw_save_entry (dw_entry_date);
	
	GtkWidget *dw_date_date_edit = lookup_widget (GTK_WIDGET (gnomedateedit), "dw_date_date_edit");
	dw_entry_date = timet_to_typedate (gnome_date_edit_get_time (GNOME_DATE_EDIT(dw_date_date_edit)));
	
	dw_load_entry (dw_entry_date);
}


void on_mwt_search_btn_clicked (GtkButton *button, gpointer user_data)
{
	mwt_search ();
}


void on_mwt_ok_btn_clicked (GtkButton *button, gpointer user_data)
{
	gtk_widget_hide (GTK_WIDGET (mwt_widget));
}


void on_make_backup_activate (GtkMenuItem *menuitem, gpointer user_data)
{
	bw_widget = create_backup_window ();
	
	gchar      file_name[50];
	GtkWidget *bw_backup_file_entry = (gpointer) lookup_widget (GTK_WIDGET (bw_widget), "bw_backup_file_entry");
	
	sprintf (file_name, "~/gnutu-backup-%d-%d-%d", date_today ().day, date_today ().month, date_today ().year);
	gnome_file_entry_set_filename (GNOME_FILE_ENTRY (bw_backup_file_entry), file_name);
	
	gtk_widget_show (GTK_WIDGET (bw_widget));
}


void on_backup_load_activate (GtkMenuItem *menuitem, gpointer user_data)
{
	lbw_widget = create_load_backup_window ();
	gtk_widget_show (GTK_WIDGET (lbw_widget));
}


void on_bw_cancel_btn_clicked (GtkButton *button, gpointer user_data)
{
	gtk_widget_hide (GTK_WIDGET (bw_widget));
}


void on_bw_save_btn_clicked (GtkButton *button, gpointer user_data)
{
	bw_make_backup ();
	gtk_widget_hide (GTK_WIDGET (bw_widget));
}


void on_lbw_cancel_btn_clicked (GtkButton *button, gpointer user_data)
{
	gtk_widget_hide (GTK_WIDGET (lbw_widget));
}


void on_lbw_load_btn_clicked (GtkButton *button, gpointer user_data)
{
	bw_load_backup  ();
	gtk_widget_hide (GTK_WIDGET (lbw_widget));
}


void on_settings_activate (GtkMenuItem *menuitem, gpointer user_data)
{
	sw_widget = create_settings_window ();
	
	sw_read_general  ();
	sw_read_left_bar ();
	
	gtk_widget_show (GTK_WIDGET (sw_widget));
}


void on_sw_cancel_btn_clicked (GtkButton *button, gpointer user_data)
{
	gtudb_settings_read ();
	
	gtk_widget_hide (GTK_WIDGET (sw_widget));
}


void on_sw_ok_btn_clicked (GtkButton *button, gpointer user_data)
{
	sw_save_general  ();
	sw_save_left_bar ();
	gtudb_settings_write ();
	
	mw_info_label_set_info ();
	
	gtk_widget_hide (GTK_WIDGET (sw_widget));
}


void on_free_days_activate (GtkMenuItem *menuitem, gpointer user_data)
{
	fdw_widget = create_free_days_window ();
	
	fdw_free_days_clist_load ();
	gtk_widget_show (GTK_WIDGET (fdw_widget));
}


void on_fdw_cancel_btn_clicked (GtkButton *button, gpointer user_data)
{
	gtudb_fd_read (); // ponownie wczytujemy baze (aby wprowadzone zmiany nie zostaly zapisane)
	gtk_widget_hide (GTK_WIDGET (fdw_widget));
}


void on_fdw_ok_btn_clicked (GtkButton *button, gpointer user_data)
{
	gtudb_fd_write ();
	gtk_widget_hide (GTK_WIDGET (fdw_widget));
}


void on_fdw_add_btn_clicked (GtkButton *button, gpointer user_data)
{
	fdw_free_days_clist_rowselected = -1;
	
	efdw_widget = create_edit_free_days_window ();
	gtk_widget_show (GTK_WIDGET (efdw_widget));
}


void on_fdw_mod_btn_clicked (GtkButton *button, gpointer user_data)
{
	efdw_widget = create_edit_free_days_window ();
	
	efdw_edit_day ();
	gtk_widget_show (GTK_WIDGET (efdw_widget));
}


void on_fdw_remove_btn_clicked (GtkButton *button, gpointer user_data)
{
	fdw_remove_free_day (fdw_free_days_clist_rowselected);
}


void on_efdw_cancel_btn_clicked (GtkButton *button, gpointer user_data)
{
	gtk_widget_hide (GTK_WIDGET (efdw_widget));
}


void on_efdw_ok_btn_clicked (GtkButton *button, gpointer user_data)
{
	if (fdw_free_days_clist_rowselected != -1)
		fdw_remove_free_day (fdw_free_days_clist_rowselected);
	
	efdw_add_free_day ();
	gtk_widget_hide (GTK_WIDGET (efdw_widget));
}


void on_fdw_free_days_clist_select_row (GtkCList *clist, gint row, gint column, GdkEvent *event, gpointer user_data)
{
	GtkWidget *fdw_mod_btn    = (gpointer) lookup_widget (GTK_WIDGET (fdw_widget), "fdw_mod_btn");
	GtkWidget *fdw_remove_btn = (gpointer) lookup_widget (GTK_WIDGET (fdw_widget), "fdw_remove_btn");
	
	gtk_widget_set_sensitive (GTK_WIDGET (fdw_mod_btn), TRUE);
	gtk_widget_set_sensitive (GTK_WIDGET (fdw_remove_btn), TRUE);
	
	fdw_free_days_clist_rowselected = row;
}


void on_fdw_free_days_clist_unselect_row (GtkCList *clist, gint row, gint column, GdkEvent *event, gpointer user_data)
{
	GtkWidget *fdw_mod_btn    = (gpointer) lookup_widget (GTK_WIDGET (fdw_widget), "fdw_mod_btn");
	GtkWidget *fdw_remove_btn = (gpointer) lookup_widget (GTK_WIDGET (fdw_widget), "fdw_remove_btn");
	
	gtk_widget_set_sensitive (GTK_WIDGET (fdw_mod_btn), FALSE);
	gtk_widget_set_sensitive (GTK_WIDGET (fdw_remove_btn), FALSE);
	
	fdw_free_days_clist_rowselected = -1;
}


gboolean on_ephw_hour_entry_key_press_event (GtkWidget *widget, GdkEventKey *event, gpointer user_data)
{
	if (event->keyval == GDK_Return) // jesli tym klawiszem jest ENTER to dodajemy nowa godzine
		on_ephw_add_hour_btn_clicked (NULL, NULL);
	
	return FALSE;
}


gboolean on_epw_subject_entry_key_press_event (GtkWidget *widget, GdkEventKey *event, gpointer user_data)
{
	if (event->keyval == GDK_Return) // jesli tym klawiszem jest ENTER to dodajemy nowa godzine
		on_epw_add_btn_clicked (NULL, NULL);
	
	return FALSE;
}


gboolean on_efdw_desc_entry_key_release_event (GtkWidget *widget, GdkEventKey *event, gpointer user_data)
{
	if (event->keyval == GDK_Return) // jesli tym klawiszem jest ENTER to dodajemy nowa godzine
		on_efdw_ok_btn_clicked (NULL, NULL);
	
	return FALSE;
}


gboolean on_import_db_window_delete_event (GtkWidget *widget, GdkEvent *event, gpointer user_data)
{
	return TRUE;
}


void on_mw_tab_info_btn_clicked (GtkButton *button, gpointer user_data)
{
	if (gtk_toggle_button_get_active (GTK_TOGGLE_BUTTON ((gpointer) lookup_widget (GTK_WIDGET (mw_widget), "mw_tab_info_btn"))) == FALSE)
		return;
	
	mw_tab_set_active_btn (1);
	
	mw_info_label_set_info ();
	
	GtkWidget *mw_notebook = (gpointer) lookup_widget (GTK_WIDGET (mw_widget), "mw_notebook");
	gtk_notebook_set_current_page (GTK_NOTEBOOK (mw_notebook), 0);
}


void on_mw_tab_stat_btn_clicked (GtkButton *button, gpointer user_data)
{
	if (gtk_toggle_button_get_active (GTK_TOGGLE_BUTTON ((gpointer) lookup_widget (GTK_WIDGET (mw_widget), "mw_tab_stat_btn"))) == FALSE)
		return;
	
	mw_tab_set_active_btn (4);
	
	GtkWidget *mw_notebook = (gpointer) lookup_widget (GTK_WIDGET (mw_widget), "mw_notebook");
	gtk_notebook_set_current_page (GTK_NOTEBOOK (mw_notebook), 3);
}


void on_fdw_add2_btn_clicked (GtkButton *button, gpointer user_data)
{
	adfdw_widget = create_add_days_free_days_window ();
	gtk_widget_show (GTK_WIDGET (adfdw_widget));
}


gboolean on_adfdw_desc_entry_key_release_event (GtkWidget *widget, GdkEventKey *event, gpointer user_data)
{
	if (event->keyval == GDK_Return) // jesli tym klawiszem jest ENTER
		on_adfdw_ok_btn_clicked (NULL, NULL);
	
	return FALSE;
}


void on_adfdw_cancel_btn_clicked (GtkButton *button, gpointer user_data)
{
	gtk_widget_hide (GTK_WIDGET (adfdw_widget));
}


void on_adfdw_ok_btn_clicked (GtkButton *button, gpointer user_data)
{
	adfdw_add_free_days ();
	gtk_widget_hide (GTK_WIDGET (adfdw_widget));
}


void on_mw_tab_at_school_btn_clicked (GtkButton *button, gpointer user_data)
{
	if (gtk_toggle_button_get_active (GTK_TOGGLE_BUTTON ((gpointer) lookup_widget (GTK_WIDGET (mw_widget), "mw_tab_at_school_btn"))) == FALSE)
		return;
	
	mw_tab_set_active_btn (2);
	
	GtkWidget *mw_notebook = (gpointer) lookup_widget (GTK_WIDGET (mw_widget), "mw_notebook");
	gtk_notebook_set_current_page (GTK_NOTEBOOK (mw_notebook), 1);
}


gboolean on_mwes_marks_time_entry_key_press_event (GtkWidget *widget, GdkEventKey *event, gpointer user_data)
{
	if (event->keyval == GDK_Return) // jesli tym klawiszem jest ENTER
		on_mwes_ok_btn_clicked  (NULL, NULL);
	
	return FALSE;
}


gboolean on_mwes_marks_subject_entry_key_press_event (GtkWidget *widget, GdkEventKey *event, gpointer user_data)
{
	if (event->keyval == GDK_Return) // jesli tym klawiszem jest ENTER
		on_mwes_ok_btn_clicked  (NULL, NULL);
	
	return FALSE;
}


gboolean on_mwes_marks_marks_entry_key_press_event (GtkWidget *widget, GdkEventKey *event, gpointer user_data)
{
	if (event->keyval == GDK_Return) // jesli tym klawiszem jest ENTER
		on_mwes_ok_btn_clicked  (NULL, NULL);
	
	return FALSE;
}


void on_mw_make_stats_clicked (GtkButton *button, gpointer user_data)
{
	mw_stats_make  ();
}


void on_mw_stats_settings_btn_clicked (GtkButton *button, gpointer user_data)
{
	mwss_show ();
}


void on_mw_diary_more_btn_clicked (GtkButton *button, gpointer user_data)
{
	on_diary_activate (NULL, NULL);
}


void on_mw_calendar_back_btn_clicked (GtkButton *button, gpointer user_data)
{
	GtkWidget *mw_calendar = (gpointer) lookup_widget (GTK_WIDGET (mw_widget), "mw_calendar");
	type_date  tmp;
	GDate     *date;
	
	gtk_calendar_get_date (GTK_CALENDAR (mw_calendar), &tmp.year, &tmp.month, &tmp.day);
	tmp.month++;
	
	date = type_date_to_gdate (tmp);
	g_date_add_days (date, -1);
	
	if (gtk_calendar_select_month (GTK_CALENDAR (mw_calendar), (gdate_to_type_date (date).month - 1), gdate_to_type_date (date).year))
		gtk_calendar_select_day (GTK_CALENDAR (mw_calendar), gdate_to_type_date (date).day);
}


void on_mw_calendar_today_btn_clicked (GtkButton *button, gpointer user_data)
{
	on_today_activate (NULL, NULL);
}


void on_mw_calendar_next_btn_clicked (GtkButton *button, gpointer user_data)
{
	GtkWidget *mw_calendar = (gpointer) lookup_widget (GTK_WIDGET (mw_widget), "mw_calendar");
	type_date  tmp;
	GDate     *date;
	
	gtk_calendar_get_date (GTK_CALENDAR (mw_calendar), &tmp.year, &tmp.month, &tmp.day);
	tmp.month++;
	
	date = type_date_to_gdate (tmp);
	g_date_add_days (date, 1);
	
	if (gtk_calendar_select_month (GTK_CALENDAR (mw_calendar), (gdate_to_type_date (date).month - 1), gdate_to_type_date (date).year))
		gtk_calendar_select_day (GTK_CALENDAR (mw_calendar), gdate_to_type_date (date).day);
}


void on_mw_notes_more_btn_clicked (GtkButton *button, gpointer user_data)
{
	mw_tab_set_active_btn (2);
	
	GtkWidget *mw_notebook = (gpointer) lookup_widget (GTK_WIDGET (mw_widget), "mw_notebook");
	gtk_notebook_set_current_page (GTK_NOTEBOOK (mw_notebook), 1);
}


void on_mwss_cancel_btn_clicked (GtkButton *button, gpointer user_data)
{
	gtk_widget_hide (GTK_WIDGET (mwss_widget));
}


void on_mwss_ok_btn_clicked (GtkButton *button, gpointer user_data)
{
	mwss_ok_btn ();
	gtk_widget_hide (GTK_WIDGET (mwss_widget));
}


void on_mwss_add_subject_btn_clicked (GtkButton *button, gpointer user_data)
{
	GtkWidget *mwss_subject_name = (gpointer) lookup_widget (GTK_WIDGET (mwss_widget), "mwss_subject_name");
	
	if (strlen ((gchar *) gtk_entry_get_text (GTK_ENTRY (mwss_subject_name))) > 0)
		mwss_add_subject ((gchar *) gtk_entry_get_text (GTK_ENTRY (mwss_subject_name)));
	
	gtk_entry_set_text (GTK_ENTRY (mwss_subject_name), "");
}


void on_mwss_remove_subject_btn_clicked (GtkButton *button, gpointer user_data)
{
	mwss_remove_subject (mwss_subject_list_rowselected);
	mwss_subject_list_rowselected = 0;
	
	GtkWidget *mwss_remove_subject_btn = (gpointer) lookup_widget (GTK_WIDGET (mwss_widget), "mwss_remove_subject_btn");
	gtk_widget_set_sensitive (GTK_WIDGET (mwss_remove_subject_btn), FALSE);
}


void on_mwss_subjects_select_row (GtkCList *clist, gint row, gint column, GdkEvent *event, gpointer user_data)
{
	GtkWidget *mwss_remove_subject_btn = (gpointer) lookup_widget (GTK_WIDGET (mwss_widget), "mwss_remove_subject_btn");
	mwss_subject_list_rowselected = row;
	
	if (row > -1)
		gtk_widget_set_sensitive (GTK_WIDGET (mwss_remove_subject_btn), TRUE);
	else
		gtk_widget_set_sensitive (GTK_WIDGET (mwss_remove_subject_btn), FALSE);
}


void on_mwss_subject_name_changed (GtkEditable *editable, gpointer user_data)
{
	GtkWidget *mwss_subject_name    = (gpointer) lookup_widget (GTK_WIDGET (mwss_widget), "mwss_subject_name");
	GtkWidget *mwss_add_subject_btn = (gpointer) lookup_widget (GTK_WIDGET (mwss_widget), "mwss_add_subject_btn");
	
	if (strlen ((gchar *) gtk_entry_get_text (GTK_ENTRY (mwss_subject_name))) > 0)
		gtk_widget_set_sensitive (GTK_WIDGET (mwss_add_subject_btn), TRUE);
	else
		gtk_widget_set_sensitive (GTK_WIDGET (mwss_add_subject_btn), FALSE);
}


gboolean on_mwss_subject_name_key_press_event (GtkWidget *widget, GdkEventKey *event, gpointer user_data)
{
	if (event->keyval == GDK_Return)
		on_mwss_add_subject_btn_clicked (NULL, NULL);

	return FALSE;
}


void on_remove_test_activate (GtkMenuItem *menuitem, gpointer user_data)
{
	if (test_menu == TRUE) {
		GtkWidget *mw_tests_clist = (gpointer) lookup_widget (GTK_WIDGET (mw_widget), "mw_tests_clist");
		gtk_clist_remove (GTK_CLIST (mw_tests_clist), mw_tests_clist_rowselected);
	} else {
		GtkWidget *mw_quizes_clist = (gpointer) lookup_widget (GTK_WIDGET (mw_widget), "mw_quizes_clist");
		gtk_clist_remove (GTK_CLIST (mw_quizes_clist), mw_quizes_clist_rowselected);
	}
}


gboolean on_mw_tests_clist_button_release_event (GtkWidget *widget, GdkEventButton *event, gpointer user_data)
{
	if ((event->button == 3) && (mw_tests_clist_rowselected > -1)) {
		GtkWidget *main_window_test_menu = (gpointer) create_main_window_test_menu ();
		gtk_menu_popup (GTK_MENU (main_window_test_menu), NULL, NULL, NULL, NULL, event->button, event->time);
		
		test_menu = TRUE;
	}
	
	return FALSE;
}


gboolean on_mw_quizes_clist_button_press_event  (GtkWidget *widget, GdkEventButton *event, gpointer user_data)
{
	if ((event->button == 3) && (mw_quizes_clist_rowselected > -1)) {
		GtkWidget *main_window_test_menu = (gpointer) create_main_window_test_menu ();
		gtk_menu_popup (GTK_MENU (main_window_test_menu), NULL, NULL, NULL, NULL, event->button, event->time);
		
		test_menu = FALSE;
	}
	
	return FALSE;
}


void on_mw_tests_clist_select_row (GtkCList *clist, gint row, gint column, GdkEvent *event, gpointer user_data)
{
	mw_tests_clist_rowselected = row;
}


void on_mw_quizes_clist_select_row (GtkCList *clist, gint row, gint column, GdkEvent *event, gpointer user_data)
{
	mw_quizes_clist_rowselected = row;
}


void on_add_subject_activate (GtkMenuItem *menuitem, gpointer user_data)
{
	on_mw_marks_add_btn_clicked (NULL, NULL);
}


void on_mod_subject_activate (GtkMenuItem *menuitem, gpointer user_data)
{
	on_mw_marks_save_btn_clicked (NULL, NULL);
}


void on_remove_subject_activate (GtkMenuItem *menuitem, gpointer user_data)
{
	on_mw_marks_delete_btn_clicked (NULL, NULL);
}


gboolean on_mw_marks_clist_button_press_event (GtkWidget *widget, GdkEventButton *event, gpointer user_data)
{
	if ((event->button == 3) && (mw_marks_clist_rowselected > -1)) {
		GtkWidget *main_window_menu = (gpointer) create_main_window_menu ();
		gtk_menu_popup (GTK_MENU (main_window_menu), NULL, NULL, NULL, NULL, event->button, event->time);
	}
	
	return FALSE;
}


void on_edit_plan_window_show (GtkWidget *widget, gpointer user_data)
{
	pw_epw_select_hour = -1;
}
